import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import { CreateProfileSalary, ProfileSalary, UpdateProfileSalary } from "../entities/ProfileSalary";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileSalaryHistory } from "../entities/ProfileSalaryHistory";
import { RequestWithUser } from "../middlewares/user";
import { Profile } from "../entities/Profile";
import { LessThan, MoreThan } from "typeorm";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile/salary")
@Tags("ProfileSalary")
@Security("bearerAuth")
export class ProfileSalaryController extends Controller {
  private profileRepo = AppDataSource.getRepository(Profile);
  private salaryRepo = AppDataSource.getRepository(ProfileSalary);
  private salaryHistoryRepo = AppDataSource.getRepository(ProfileSalaryHistory);

  @Get("user")
  public async getSalaryUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const record = await this.salaryRepo.find({
      where: { profileId: profile.id },
      order: { order: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("{profileId}")
  public async getSalary(@Path() profileId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileId, "SYS_REGISTRY_OFFICER");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_OFFICER", profileId);
    const record = await this.salaryRepo.find({
      where: { profileId: profileId },
      order: { order: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("admin/{profileId}")
  public async getSalaryAdmin(@Path() profileId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileId, "SYS_SALARY_OFFICER");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_SALARY_OFFICER");
    const record = await this.salaryRepo.find({
      where: { profileId: profileId },
      order: { order: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("admin/history/{salaryId}")
  public async salaryAdminHistory(@Path() salaryId: string, @Request() req: RequestWithUser) {
    const _record = await this.salaryRepo.findOneBy({ id: salaryId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, salaryId, "SYS_REGISTRY_OFFICER");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_OFFICER", _record.profileId);
    }
    const record = await this.salaryHistoryRepo.find({
      where: {
        profileSalaryId: salaryId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("history/{salaryId}")
  public async salaryHistory(@Path() salaryId: string) {
    const record = await this.salaryHistoryRepo.find({
      where: {
        profileSalaryId: salaryId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newSalary(@Request() req: RequestWithUser, @Body() body: CreateProfileSalary) {
    if (!body.profileId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileId");
    }

    const profile = await this.profileRepo.findOneBy({ id: body.profileId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_OFFICER", profile.id);

    const dest_item = await this.salaryRepo.findOne({
      where: { profileId: body.profileId },
      order: { order: "DESC" },
    });
    const before = null;
    const data = new ProfileSalary();

    const meta = {
      order: dest_item == null ? 1 : dest_item.order + 1,
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileSalaryHistory();
    Object.assign(history, { ...data, id: undefined });
    await this.salaryRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileSalaryId = data.id;
    await this.salaryHistoryRepo.save(history, { data: req });

    return new HttpSuccess();
  }

  @Post("update")
  public async updateSalary(@Request() req: RequestWithUser, @Body() body: CreateProfileSalary) {
    if (!body.profileId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileId");
    }

    const profile = await this.profileRepo.findOneBy({ id: body.profileId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_OFFICER", profile.id);

    const dest_item = await this.salaryRepo.findOne({
      where: { profileId: body.profileId },
      order: { order: "DESC" },
    });
    const before = null;
    const data = new ProfileSalary();

    const meta = {
      order: dest_item == null ? 1 : dest_item.order + 1,
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileSalaryHistory();
    Object.assign(history, { ...data, id: undefined });
    await this.salaryRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileSalaryId = data.id;
    await this.salaryHistoryRepo.save(history, { data: req });

    let null_:any = null;
    profile.amount = body.amount ?? null_;
    profile.positionSalaryAmount = body.positionSalaryAmount ?? null_;
    profile.mouthSalaryAmount = body.mouthSalaryAmount ?? null_;
    await this.profileRepo.save(profile);
    return new HttpSuccess();
  }

  @Patch("{salaryId}")
  public async editSalary(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileSalary,
    @Path() salaryId: string,
  ) {
    const record = await this.salaryRepo.findOneBy({ id: salaryId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_OFFICER", record.profileId);
    const before = structuredClone(record);
    const history = new ProfileSalaryHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileSalaryId = salaryId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.salaryRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.salaryHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{salaryId}")
  public async deleteSalary(@Path() salaryId: string, @Request() req: RequestWithUser) {
    const _record = await this.salaryRepo.findOneBy({ id: salaryId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_OFFICER",
        _record.profileId,
      );
    }
    const data = await this.salaryRepo.findOneBy({ id: salaryId });
    if (!data) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (data == null) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    const profileId = data.profileId;
    await this.salaryHistoryRepo.delete({
      profileSalaryId: salaryId,
    });

    const result = await this.salaryRepo.delete({ id: salaryId });

    const salaryList = await this.salaryRepo.find({
      where: {
        profileId: profileId,
      },
    });
    salaryList.forEach(async (p, i) => {
      p.order = i + 1;
      await this.salaryRepo.save(p);
    });
    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }

  @Get("swap/{direction}/{salaryId}")
  public async swapSalary(
    @Path() direction: string,
    salaryId: string,
    @Request() req: RequestWithUser,
  ) {
    const source_item = await this.salaryRepo.findOne({ where: { id: salaryId } });
    // if (source_item) {
    //await new permission().PermissionOrgUserGet(req,"SYS_REGISTRY_OFFICER",source_item.profileId,); //ไม่แน่ใจOFFปิดไว้ก่อน
    // }
    if (source_item == null) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    const sourceOrder = source_item.order;
    if (direction.trim().toUpperCase() == "UP") {
      const dest_item = await this.salaryRepo.findOne({
        where: { profileId: source_item.profileId, order: LessThan(sourceOrder) },
        order: { order: "DESC" },
      });
      if (dest_item == null) return new HttpSuccess();
      var destOrder = dest_item.order;
      dest_item.order = sourceOrder;
      source_item.order = destOrder;
      await Promise.all([this.salaryRepo.save(source_item), this.salaryRepo.save(dest_item)]);
    } else {
      const dest_item = await this.salaryRepo.findOne({
        where: { profileId: source_item.profileId, order: MoreThan(sourceOrder) },
        order: { order: "ASC" },
      });
      if (dest_item == null) return new HttpSuccess();
      var destOrder = dest_item.order;
      dest_item.order = sourceOrder;
      source_item.order = destOrder;
      await Promise.all([this.salaryRepo.save(source_item), this.salaryRepo.save(dest_item)]);
    }
    return new HttpSuccess();
  }
}
